#version 330

//---------------------------------------------------------------------------
uniform vec4 gColor;
uniform sampler2D gSampler;
//---------------------------------------------------------------------------
in vec2 s_TexCoord;
//---------------------------------------------------------------------------
layout (location = 0) out vec4 outColor;
layout (location = 1) out vec4 outBrightColor;
//---------------------------------------------------------------------------
void main()
{
	outColor = texture(gSampler, s_TexCoord) * gColor;

    // Check whether fragment output is higher than threshold, if so output as brightness color
	float brightness = dot(outColor.rgb, vec3(0.2126, 0.7152, 0.0722));
    if(brightness > 1.0)
	{
        outBrightColor = outColor;
	}
	else
	{
		outBrightColor = vec4(0.0, 0.0, 0.0, 0.0);
	}
}
