#version 330

//---------------------------------------------------------------------------
layout(location = 0) in vec3 inPosition;
layout(location = 1) in vec2 inCoord;
//---------------------------------------------------------------------------
uniform mat4 gModelViewMat;
uniform mat4 gProjMat;
uniform vec2 gScale = vec2(1, 1);
uniform float gRotation = 0;
//---------------------------------------------------------------------------
out vec2 s_TexCoord;
//---------------------------------------------------------------------------
mat4 RotationMatrix(vec3 axis, float angle)
{
    axis = normalize(axis);
    float s = sin(angle);
    float c = cos(angle);
    float oc = 1.0 - c;
    
    return mat4(oc * axis.x * axis.x + c,           oc * axis.x * axis.y - axis.z * s,  oc * axis.z * axis.x + axis.y * s,  0.0,
                oc * axis.x * axis.y + axis.z * s,  oc * axis.y * axis.y + c,           oc * axis.y * axis.z - axis.x * s,  0.0,
                oc * axis.z * axis.x - axis.y * s,  oc * axis.y * axis.z + axis.x * s,  oc * axis.z * axis.z + c,           0.0,
                0.0,                                0.0,                                0.0,                                1.0);
}
//---------------------------------------------------------------------------
void main()
{
    gl_Position = gProjMat * ((gModelViewMat * vec4(0.0, 0.0, 0.0, 1.0)) 
							+ vec4(inPosition.x, inPosition.y, 0.0, 0.0) 
								* vec4(gScale.x, gScale.y, 1.0, 1.0)
								* RotationMatrix(vec3(0,0,1), gRotation)); 
	s_TexCoord = inCoord;
}
