#version 330

in vec2 TexCoords;

uniform sampler2D gSampler;
uniform bool gHorizontal;

uniform float s_Weight[5] = float[] (0.2270270270, 0.1945945946, 0.1216216216, 0.0540540541, 0.0162162162);

out vec4 outColor;

void main()
{             
     vec2 tex_offset = 1.0 / textureSize(gSampler, 0);
     vec3 result = texture(gSampler, TexCoords).rgb * s_Weight[0];

     if(gHorizontal)
     {
         for(int i = 1; i < 5; ++i)
         {
            result += texture(gSampler, TexCoords + vec2(tex_offset.x * i, 0.0)).rgb * s_Weight[i];
            result += texture(gSampler, TexCoords - vec2(tex_offset.x * i, 0.0)).rgb * s_Weight[i];
         }
     }
     else
     {
         for(int i = 1; i < 5; ++i)
         {
             result += texture(gSampler, TexCoords + vec2(0.0, tex_offset.y * i)).rgb * s_Weight[i];
             result += texture(gSampler, TexCoords - vec2(0.0, tex_offset.y * i)).rgb * s_Weight[i];
         }
     }

     outColor = vec4(result, 1.0);
}