#version 330 

//---------------------------------------------------------------------------
uniform float gFXAASubpixShift = 1.0/4.0;
uniform vec2 gSampleSize;
//---------------------------------------------------------------------------
layout (location = 0) in vec2 inPosition;
layout (location = 1) in vec2 inTexCoords;
//---------------------------------------------------------------------------
out vec4 posPos;
out vec2 TexCoords;
//---------------------------------------------------------------------------
void main(void)
{
    gl_Position = vec4(inPosition.x, inPosition.y, 0.0f, 1.0f); 
    TexCoords = inTexCoords;

	vec2 rcpFrame = vec2(1.0/gSampleSize.x, 1.0/gSampleSize.y);
	posPos.xy = inTexCoords.xy;
	posPos.zw = inTexCoords.xy - (rcpFrame * (0.5 + gFXAASubpixShift));
}
