#version 330

//---------------------------------------------------------------------------
uniform sampler2D gSampler;
uniform sampler2D gDirt;
uniform sampler2D gStarburst;
uniform mat3 gStarburstMatrix;
//---------------------------------------------------------------------------
noperspective in vec2 TexCoords;
//---------------------------------------------------------------------------
out vec4 outColor;
//---------------------------------------------------------------------------
void main() 
{ 
	vec4 lensMod = texture(gDirt, TexCoords);
	
	vec2 lensStarTexcoord = (gStarburstMatrix * vec3(TexCoords, 1.0)).xy;
	lensMod += texture(gStarburst, lensStarTexcoord);

	outColor = texture(gSampler, TexCoords) * lensMod;
}
