#version 330

#define FADE_TIME 0.3

layout(points) in;
layout(triangle_strip) out;
layout(max_vertices = 4) out;

in float s_LifeTime[];

uniform mat4 gProjMatrix;
uniform float gBillboardSize;

out vec2 s_TexCoord;
out vec4 s_Color;

const vec2 corners[4] = vec2[4]( vec2(0.0, 1.0), vec2(0.0, 0.0), vec2(1.0, 1.0), vec2(1.0, 0.0) );

void main()
{
    for (int i = 0; i < 4; ++i)
    {
        vec4 eyePos = gl_in[0].gl_Position;
        eyePos.xy += gBillboardSize * (corners[i] - vec2(0.5));
        gl_Position = gProjMatrix * eyePos;
        s_TexCoord = corners[i];
		s_Color = vec4(1);

		if (s_LifeTime[0] < FADE_TIME)
		{			
			s_Color.w = 1 - (FADE_TIME - s_LifeTime[0])/FADE_TIME;
		}

        EmitVertex();
    }
}
