#version 330 core

//---------------------------------------------------------------------------
uniform sampler2D gSamplerHorizon;
uniform sampler2D gSamplerSun;
//---------------------------------------------------------------------------
in vec3 s_SunPos;
in vec3 s_Pos;
//---------------------------------------------------------------------------
layout (location = 0) out vec4 outColor;
layout (location = 1) out vec4 outBrightColor;
layout (location = 2) out vec4 outDepth;
//---------------------------------------------------------------------------
void main()
{   
	vec3 pos = normalize(s_Pos);

    // Calculate proximity to sun
	float prox = dot(pos, s_SunPos);

    // Look up textures
    vec4 horizColor = texture(gSamplerHorizon, vec2((s_SunPos.y + 1.0) / 2.0, pos.y));
    vec4 sunColor = texture(gSamplerSun,  vec2((s_SunPos.y + 1.0) / 2.0, prox));

    outColor = vec4(horizColor.rgb * horizColor.a + sunColor.rgb * sunColor.a / 2.0, 1);
	outBrightColor = vec4(0, 0, 0, 1);
	outDepth = vec4(1, 0, 0, 1);
}
