#version 330

layout (location = 0) out vec4 outColor;
layout (location = 1) out vec4 outBrightColor;

uniform vec3 gColor;

void main()
{
	outColor = vec4(gColor, 1);

    // Check whether fragment output is higher than threshold, if so output as brightness color
    float brightness = dot(outColor.rgb, vec3(0.2126, 0.7152, 0.0722));
    if(brightness > 1.0)
	{
        outBrightColor = vec4(outColor.rgb, 1.0);
	}
	else
	{
		outBrightColor = vec4(0.0f, 0.0f, 0.0f, 1.0f);
	}
}
