#version 330

layout (location = 0) in vec3 inPosition;
layout (location = 1) in vec2 inCoord;
layout (location = 2) in vec3 inNormal;

uniform mat4 gMVP;
uniform mat4 gModelMat;

out vec2 TexCoord;
out vec3 Normal;
out vec3 WorldPos;

void main()
{
	gl_Position = gMVP * vec4(inPosition, 1.0);
	TexCoord = inCoord;
	Normal	= (gModelMat * vec4(inNormal, 0.0)).xyz;
	WorldPos = (gModelMat * vec4(inPosition, 1.0)).xyz; 
}